        program saf2fasta
!** 25-AUG-98  modified to keep max of 1000 sequences.
!** 17-JUL-98  modified to sort baes on %ID to the parent sequence
!** 7-JUL-98 make identifier at least 10 chars. Omit training numbers.
!** 18-MAY-98 convert SAF to HSSP format
        implicit none
        character(len=800) :: aline
        character(len=80) :: arg1
        integer :: I,J,K,iparent,istart,M,N,ires,jres,ios=0,L,Q,NN
        character(len=80) :: infile,outfile
        character(len=1),dimension(:,:),allocatable :: msa
        character(len=11),dimension(:),allocatable :: pline
        character(len=1) :: chainID
        character(len=4) :: code
        logical,dimension(:),allocatable :: onoff
        integer,dimension(:),allocatable :: nid,mid,sposit,start,finish
        real,dimension(:),allocatable :: spid
        integer :: jarg,II,JJ,iblock,nblock,KK,MM,LL,ngap,SL,L1,L2,NF
        integer,parameter :: MAXLINE=700
        integer :: A(20),B(20)
        integer :: MINIDLEN=11, MAXIDLEN=20
        real :: id,x
!** function
        integer :: iargc,getfields
        character(len=80) :: lcase
!**
        jarg = iargc()
        istart = 1
        iparent = 1
        chainID = " "
        code = "pred"
        if (jarg<2) then
          write(*,'("xsaf2fasta saf_file fastafile")')
          stop 'saf2fasta.f90 Sat Dec 12 11:18:56 EST 2009'
        endif
        call getarg(1,infile)
        call getarg(2,outfile)

        open(11,file=infile,status='old',form='formatted')
        write(*,*) 'Writing FASTA file: ',trim(outfile)
        open(12,file=outfile,status='replace',form='formatted')
!** find out how many total sequences
        aline = " "
        do while (aline(1:1)==" ".or.aline(1:1)=="#")
          if (aline(1:1)=="#") write(12,'("REMARK ",a)') trim(aline)
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) stop 'Premature end of input!'
        enddo
        N = 0
        do while (aline(1:1)/=" ".and.aline(1:1)/="#")
          N = N + 1
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) exit
        enddo
        write(*,*) N,' sequences'
        NN = N
        if (NN > 1000) then
          NN = 1000
          write(*,*) ' Using 1000 sequences.'
        endif
!** get sequence alignment length, and number of alignment blocks
        L = 0; J = 0
        rewind(11)
        aline = " "
        do while (aline(1:1)==" ".or.aline(1:1)=="#")
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) stop 'Premature end of input!'
        enddo
        do    ! start of block of sequences here
          J = J + 1
          call getseqfield(aline,L1,L2)
          write(*,'("Block",i4," Sequence field is characters ",i4,i4)') J,L1,L2
          L = L + L2 - L1 + 1
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) exit
          do while (aline(1:1)/=" ".and.aline(1:1)/="#")
            read(11,'(a)',iostat=ios) aline
            if (ios/=0) exit
          enddo
          if (ios/=0) exit
          do while (aline(1:1)==" ".or.aline(1:1)=="#") ! find next block
            read(11,'(a)',iostat=ios) aline
            if (ios/=0) exit
          enddo
          if (ios/=0) exit
        enddo
        nblock = J
        write(*,*) "Length = ",L
        M = L  ! maximum sequence length
        allocate(onoff(M),msa(M+1,N),nid(N),mid(N),stat=ios)
        if (ios/=0) stop 'Failed allocating onoff, msa, nid, mid'
        allocate(pline(N),spid(N),sposit(N),start(N),finish(N),stat=ios)
        if (ios/=0) stop 'Failed allocating spid, sposit, start, finish'
        pline = " "
        sposit = 0
        spid = 0
        onoff = .false.; msa = " "
!** read sequences. ALL MUST BE THE SAME LENGTH!!
!** SAME NUMBER IN EACH BLOCK. SAME ORDER.  
        I = 1
        start=0; finish=0
        nid=0;mid=0
        rewind(11)
        Q = 0
        L = 0
        aline = " "
        do while (aline(1:1)==" ".or.aline(1:1)=="#")
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) stop 'Premature end of input!'
        enddo
        do   !! new block
            !! diagnostic
          write(*,'(a)') trim(aline)
          call getseqfield(aline,L1,L2)
          J = 0  ! seq number
          do while (aline(1:1)/=" ".and.aline(1:1)/="#")
            L = Q          ! Q = last residue in previous block
            J = J + 1
            !! diagnostic
            !! write(*,*) J
            if (J > N) stop 'BUG!! J > N '
            do I=L1,L2
              L=L+1
              if (L > M) stop 'BUG!! L > M '
              msa(L,J)=aline(I:I)
            enddo
            read(11,'(a)',iostat=ios) aline
            if (ios/=0) exit
            if (aline(1:1)==" ".or.aline(1:1)=="#") exit
            !! correct pathological behavior of BLASTPGP
            !! sometimes puts garbage, include <rtn> at end
            !! of lines, making extra lines. Look for blanks in
            !! the sequence field. Omit these lines.
            !! 18-AUG-00 C.Bystroff
            if (aline(L1:L1)==" ".or.aline(L2:L2)==" ") then
              read(11,'(a)',iostat=ios) aline
            endif
            if (ios/=0) exit
          enddo
          Q = L 
          if (ios/=0) exit
          do while (aline(1:1)==" ".or.aline(1:1)=="#")
            read(11,'(a)',iostat=ios) aline
            if (ios/=0) exit
          enddo
          if (ios/=0) exit
        enddo
        !! diagnostic
        write(*,'("done reading sequences.")')
!** get sequence length
        SL = 0
        do I=1,M
          if (msa(I,iparent)>="A".and.msa(I,iparent)<="Z") SL = SL + 1
        enddo
        write(*,'(a,i4)') "SEQLENGTH  ",SL
        write(*,'("NALIGN",i9)') NN
!** do it again. Get %ID this time.
        I = 1
        nid=0;mid=0
        do J=1,N
          do L=1,M
            if ((msa(L,iparent)/="-".and.msa(L,iparent)/=".") &
              .and.(msa(L,J)/="-".and.msa(L,J)/=".")) then
              mid(J) = mid(J) + 1
              if (msa(L,iparent)==msa(L,J)) nid(J) = nid(J) + 1
            endif
          enddo
        enddo
!** get start and finish positions
        do J=1,N
          do L=1,M
            if (msa(L,J)/="-".and.msa(L,J)/=".") then
              if (start(J)==0) start(J) = L
              finish(J) = L
            endif
          enddo
        enddo
        write(*,*) 'Done reading sequences',M,N
!** read identifier lines
        rewind(11)
        aline = " "
        do while (aline(1:1)==" ".or.aline(1:1)=="#")
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) stop 'Premature end of input!'
        enddo
        J = 0
        do while (aline(1:1)/=" ".and.aline(1:1)/="#")
          J = J + 1
          NF = getfields(20,aline,A,B)
          x = 0.
          if (mid(J)>0) x = real(nid(J))/real(mid(J))
          spid(J) = x
          pline(J) = aline(A(1):B(1))
          read(11,'(a)',iostat=ios) aline
          if (ios/=0) exit
        enddo
!** sort by percent id (spid) 
        call sortpid(spid,sposit,N)
!** output sorted PROTEINS lines
        !do J=1,NN
        !  write(12,'(i5," : ",a,t29,f4.2,2i8)') J,pline(sposit(J)),spid(sposit(J)),start(sposit(J)),finish(sposit(J))
        !enddo
        !write(*,*) "Done writing PROTEINS lines"
        deallocate(nid,mid,spid)
!** eliminate extensions, mark gaps in parent sequence
        onoff = .true.
        J = iparent
        K = 1
        do while (msa(K,J)==".".or.msa(K,J)=="-")
          msa(K,J)=" "
          onoff(K) = .false.
          K = K + 1
        enddo
        LL = K      ! 1st nonblank in parent sequence.
        K = M
        do while (msa(K,J)==".".or.msa(K,J)=="-")
          msa(K,J)=" "
          onoff(K) = .false.
          K = K - 1
          if (K<1) exit
        enddo
        MM = K
        do J=1,N
          K = LL
          !! trim N-term
          do while (msa(K,J)==".".or.msa(K,J)=="-" &
                        .or.msa(K,J)==" ")
            msa(K,J)=" "
            K = K + 1
          enddo
          !! trim C-term
          K = MM
          do while (msa(K,J)==".".or.msa(K,J)=="-" &
                        .or.msa(K,J)==" ")
            msa(K,J)=" "
            K = K - 1
            if (K<1) exit  ! no non-gap characters found!!
          enddo
          do while (K>=LL)
            !! find gaps, write "."
            if (msa(K,J)=="-".or.msa(K,J)==".") then
              msa(K,J)="-"
              if (J==iparent) then
                onoff(K) = .false.
                do JJ=1,N
                  if (JJ==iparent) cycle
                  !! mark insertion points in other seqs when gapped in parent
                  if ((msa(K,JJ)>="A".and.msa(K,JJ)<="Z") &
                     .or.(msa(K,JJ)>="a".and.msa(K,JJ)<="z")) then
                    if (K>LL.and.K<MM) then
                      KK = K-1
                      !! traverse insertion region. 
                      !! 1st traverse any internal gap
                      do while (msa(KK,JJ)=="-".or.msa(KK,JJ)=="." &
                        .or.msa(KK,JJ)==" ")
                        KK = KK - 1; if (KK<LL) exit
                      enddo
                      if (KK<LL) cycle ! JJ
                      if (msa(KK,JJ)>="A".and.msa(KK,JJ)<="Z") then
                        Q = KK
                        KK = K+1
                        do while (msa(KK,JJ)=="-".or.msa(KK,JJ)=="." &
                        .or.msa(KK,JJ)==" ")
                          KK = KK + 1; if (KK>MM) exit
                        enddo
                        if (KK>MM) cycle
                        if (msa(KK,JJ)>="A".and.msa(KK,JJ)<="Z") then
                          ! msa(KK,JJ) = lcase(msa(KK,JJ))
                        endif
                        ! msa(Q,JJ) = lcase(msa(Q,JJ))
                      endif
                    endif
                  endif
                enddo
              endif
            endif
            K = K - 1
          enddo
        enddo
!** write out alignment in FASTA format
        do I=1,NN
          write(12,'("> ",i5)') I
          do J=1,MM
            if ( msa(J,I) == " " )  msa(J,I) = "-"
            write(12,'(a1,$)') msa(J,I)
          enddo
          write(12,*)
        enddo
        close(12)
        CONTAINS
!===============================================================!
        subroutine getseqfield(aline,L1,L2)
!! limit 20 fields
        implicit none
        integer :: getfields
        integer :: NF,L1,L2
        character(len=*) :: aline
        integer :: A(20),B(20)
        integer :: k, ios=0
!!
        NF = getfields(20,aline,A,B)
!** If there are no sequence numbers there will be 2 fields
!** otherwise four fields
        if (NF == 2) then
          L1 = A(2)
          L2 = B(2)
        elseif (NF == 4) then
          L1 = A(3)
          L2 = B(3)
!!  If there are three fields, then either field 2 or field 3 is
!! a number field. If reading it gives no error, then it's a number field.
        elseif (NF == 3) then
          read(aline(A(2):B(2)),*,iostat=ios) k
          if (ios/=0) then ! field 2 is not a number field; assume field 2 is sequence
            L1 = A(2)
            L2 = B(2)
          else  ! field 2 is numerical
            read(aline(A(3):B(3)),*,iostat=ios) k
            if (ios/=0) then ! field 3 is not a number field; assume field 3 is sequence
              L1 = A(3)
              L2 = B(3)
            else  ! both fields are numbers !! 
              write(*,'("SAF file has unreadable format!!!",/,a)') trim(aline)
              write(*,'("3 Block line must have a non-numerical field")')
              stop 'Error... unreadable SAF file (3)'
            endif
          endif
        else
          write(*,'("SAF file has unreadable format!!!",/,a)') trim(aline)
          write(*,'("First line in Block must have 2, 3 or 4 fields")')
          stop 'Error... unreadable SAF file (2)'
        endif
        end subroutine getseqfield
!===============================================================!
        end program saf2fasta
!*************************************************************
        character*(*) function lcase(card)
        character*(*) card
        integer I,icap
        icap = ichar('a') - ichar('A')
        do I=1,len(card)
        if ('A'.le.card(I:I).and.card(I:I).le.'Z') &
        card(I:I) = char(ichar(card(I:I))+icap)
        enddo
        lcase = card
        return
        end
!**********************************************************************
        subroutine sortpid(spid,sposit,N)
        implicit none
        integer,intent(in) :: N
        real,dimension(N),intent(in) :: spid
        integer,dimension(N),intent(out) :: sposit
        integer :: I,J,K,ios=0
        real,dimension(:),allocatable :: sortedpid
        real :: x
!cb      if (N > MAXSEQ) stop 'INCREASE dimension in sortpid()'
        allocate(sortedpid(N),stat=ios)
        if (ios /= 0) stop 'ERROR allocating sortdpid(). TOO MANY SEQUENCES'
        sposit = 0
        sortedpid = -1.
        do I=1,N
          x = spid(I)
          K = N + 1
          do while (x > sortedpid(K-1))
            if (K <= N) then
              sposit(K) = sposit(K-1)
              sortedpid(K) = sortedpid(K-1)
            endif
            K = K - 1
            if (K == 1) exit
          enddo
          sortedpid(K) = x
          sposit(K) = I
        enddo
        deallocate(sortedpid,stat=ios)
        end subroutine sortpid
!************************************************************

!************************************************************************
!* find the limits of up to N fields of non-blank
!* characters in the string 'aline' . The start of
!* field I is A(I), the end is B(I)
        integer function getfields(N,aline,A,B)
        implicit none
        integer,intent(inout) ::  N,A(N),B(N)
        integer ::  I,FF,LL
        character(len=*),intent(in) :: aline
!**
        I = 1
        FF = 0
        LL = len(aline)
        do while (FF.lt.N.and.I.le.LL)
          do while (aline(I:I).eq.' '.and.I.le.LL)
            I = I + 1
          enddo
          if (I.le.LL) then
            FF = FF+1
            A(FF) = I
            do while (aline(I:I).ne.' '.and.I.le.LL)
              I = I + 1
            enddo
            B(FF) = I-1
          endif
        enddo
        getfields = FF
        end function getfields
!************************************************************************

